/*************************************************************************************************
* CCD Output - braille project C5402 target software
* Andrew Paquale 09913770
* 26/7/2002
*************************************************************************************************/

#include <type.h>
#include <board.h>
#include <codec.h>
#include <mcbsp54.h>
#include <stdio.h>
#include "target.h"
#include "intr.h"

void codewheel_interrupt0();
void SI_interrupt2();
void setup_interrupt();


/**************** Global Variables**********************/

HANDLE hHandset;
s16 data;
int data_array[60];
static short codewheel_var = 0;
int i = 0, newline_var = 0;
int reference_amplitude, reference_amplitudeL, reference_amplitudeR;		
int sam31, sam32, sam33, sam34, sam35, sam36, sam37;	//sample number, fuzzy dot variable
int sam38, sam39, sam40, sam41, sam42, sam43;	//sample number, fuzzy dot variable
int sam44, sam45, sam46, sam47, sam48;	//sample number, fuzzy dot variable
int dot1, dot2, dot3, dot1_value, dot2_value, dot3_value;
int dot1_new, dot2_new, dot3_new, dot1_old1, dot2_old1, dot3_old1;
int slice_new, slice_old1, slice_old2;
int braille_cell, slice_goodnew, slice_good1, slice_good2, slice_good3, slice_good4, slice_good5;
int slice_good6, slice_good7, slice_good8, slice_good9, slice_good10, slice_good11, slice_good12;
int slice_good13, slice_good14, slice_good15, slice_good16, slice_good17, slice_good18;
char temp[80];

/* 0 = space, 6(dot) = 1(binary) = capital indicator,  1-2-3-6(dot) = 39 (bin) = 'v' etc
- does not include single sided cells (* = single side) (always does letter), or prefix's
- bin2CAP is capital equivalent, bin2NUM is decimal equivalent
    
Dec|Braille|Meaning                                                            |ASCII

0	000 000	space	
1*	000 001	capital indicator, prefix for certain contractions 	                ,
2*	000 010	prefix for certain contractions 	                                "
3*	000 011	letter indicator, prefix for certain contractions 	                ;
4*	000 100	accent indicator 	                                                @
5*	000 101	decimal point, emphasis indicator, prefix for certain contractions 	.
6*	000 110	prefix for certain contractions 	                                ^
7*	000 111	prefix for certain contraction	                                    _
8*	001 000	apostrophe (') 	                                                    '
9	001 001	hyphen (-), contraction "com" 	                                    -
10	001 010	contraction "in" 	                                                9
11	001 011	closing quote, contraction "was" 	                                0
12	001 100	slash (/), contraction "st" 	                                    /
13	001 101	contraction "ing" 	                                                +
14	001 110	contraction "ar" 	                                                >
15	001 111	numeric indicator, contraction  "ble" 	                            #
16*	010 000	comma (,), contraction "ea" 	                                    1
17	010 001	contraction "en" 	                                                5
18	010 010	colon (:), contraction "cc" 	                                    3
19	010 011	period (.), contraction "dis" 	                                    4
20	010 100	i, 9 	                                                            i
21	010 101	contraction "ow" 	                                                [
22	010 110	j, 0, contraction "just" 	                                        j
23	010 111	w, contraction "will" 	                                            w
24*	011 000	semicolon (;), contraction "bb" 	                                2
25	011 001	opening quote, contraction "his" 	                                8
26	011 010	exclamation (!), contraction "to" 	                                6
27	011 011	opening or closing round parenthesis, contraction "gg" 	            7
28	011 100	s, contraction "so" 	                                            s
29	011 101	contraction "the" 	                                                !
30	011 110	t, contraction "that" 	                                            t
31	011 111	contraction "with" 	                                                )
32*	100 000	letter a, digit 1 	                                                a
33	100 001	contraction "ch" 	                                                *
34	100 010	e, 5, contraction "every" 	                                        e
35	100 011	contraction "wh" 	                                                :
36	100 100	c, 3, contraction "can" 	                                        c
37	100 101	contraction "sh" 	                                                %
38	100 110	d, 4, contraction "do" 	                                            d
39	100 111	contraction "th" 	                                                ?
40*	101 000	k, contraction "knowledge" 	                                        k
41	101 001	u, contraction "us" 	                                            u
42	101 010	o 	                                                                o
43	101 011	z, contraction "as" 	                                            z
44	101 100	m, contraction "more" 	                                            m
45	101 101	x, contraction "it" 	                                            x
46	101 110	n, contraction "not" 	                                            n
47	101 111	y, contraction "you" 	                                            y
48*	110 000	b, 2, contraction "but" 	                                        b
49	110 001	contraction "gh" 	                                                <
50	110 010	h, 8, contraction "have" 	                                        h
51	110 011	contraction "ou" 	                                                \
52	110 100	f, 6, contraction "from"                                        	f
53	110 101	contraction "ed"                                                	$
54	110 110	g, 7, contraction "go" 	                                            g
55	110 111	contraction "er" 	                                                ]
56*	111 000	l, contraction "like                                            	l
57	111 001	v, contraction "very"	                                            v
58	111 010	r, contraction "rather" 	                                        r
59	111 011	contraction "of" 	                                                (
60	111 100	p, contraction "people"                                         	p
61	111 101	contraction "and" 	                                                &
62	111 110	q, contraction "quite" 	                                            q
63	111 111	contraction "for" 	                                                =
*/
//North American ASCII equivalent,
/*char bin2char[64] = {' ',',','"',';','@','.','^','_','','',
					 '','','','','','','','','','',
					 '','','','','','','','','','',
					 '','','','','','','','','','',,
					 '','','','','','','','','','',
					 '','','','','','','','','','',
					 '','','',''};*/

char bin2char[64] = {' ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'-',
					  NULL,'"','/',NULL,NULL,NULL,',',NULL,':','.',
					  'i',NULL,'j','w','"','!',NULL,'(','s',NULL,
					  't',NULL,'a',NULL,'e',NULL,'c',NULL,'d',NULL,
					  'k','u','o','z','m','x','n','y','b',NULL,
					  'h',NULL,'f',NULL,'g',NULL,'l','v','r',NULL,
					  'p',NULL,'q',NULL};
char bin2CAP[64] = {  NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
					  NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
					  'I',NULL,'J','W',NULL,NULL,NULL,NULL,'S',NULL,
					  'T',NULL,'A',NULL,'E',NULL,'C',NULL,'D',NULL,
					  'K','U','O','Z','M','X','N','Y','B',NULL,
					  'H',NULL,'F',NULL,'G',NULL,'L','V','R',NULL,
					  'P',NULL,'Q',NULL};				  
char bin2NUM[64] = {  NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
					  NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
					  '9',NULL,'0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,
					  NULL,NULL,'1',NULL,'5',NULL,'3',NULL,'4',NULL,
					  NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2',NULL,
					  '8',NULL,'6',NULL,'7',NULL,NULL,NULL,NULL,NULL,
					  NULL,NULL,NULL,NULL};

char bin2contr[64][12] = {"", "", "", "","","","","","","com"
						"in", "was", "st", "ing","ar","ble","ea","en","cc","dis"
						"", "ow", "just", "will","bb","his","to","gg","so","the"
						"that", "with", "", "ch","every","wh","can","sh","do","th"
						"knowledge", "us", "", "as","more","it","not","you","but","gh"
						"have", "ou", "from", "ed","go","er","like","very","rather","of"
						"people", "and", "quite", "for"};

/*************************************************************************************************
--------------------------------------- Main function --------------------------------------------
1. set up interrupts
2. set up tlc320AD50 (initailise MsCbs serial port, set sampling rate etc)
3. wait for events
*************************************************************************************************/

void main()
{
    
    if (brd_init(100))
        return;

//------------------1. set up interrupts------------------	
	
	INTR_INIT								//initailise pointer to vector table
	INTR_HOOK( 16,codewheel_interrupt0)		//put ISR into vector table
	INTR_HOOK( 18,SI_interrupt2)			//put ISR into vector table
	
	// Setup the interrupt handler
	setup_interrupt();
	port0 = 0x80;			//sets CNTL1 register, enable int2
	
//------------------2. Setup the ADC -------------------	
	
    /* Open Handset Codec */
    hHandset = codec_open(HANDSET_CODEC);               // Acquire handle to codec 

    // Set codec parameters 
    codec_adc_mode(hHandset, CODEC_ADC_15BIT);          // ADC in 15-bit mod
    codec_ain_gain(hHandset, CODEC_AIN_0dB);            // 0dB gain on analog input to ADC 
    codec_sample_rate(hHandset,SR_16000);               // 16KHz sampling rate 
	i = 0;

while (1);
    /* Polling and digital loopback */
    
	return;
	
/* END of Main */
}


/************************************************************************************************
---------------------------- codewheel_interrupt --------------------------------------------
The SI Pulse provides an interrupt to X_INT1 every 5.3 mS, 
the DSP will only process the CCD image slice from the AIC if 
a X_INT0 event (indicating a codewheel trigger signal) 
occurred in the last 5.3 mS AND XF equals zero (indicating forward motion)
*************************************************************************************************/
interrupt void codewheel_interrupt0()
{
asm(" SSBX INTM");		// Disable interrupts


codewheel_var = bio_test();		//test to see if codewheel is moving forward
if (codewheel_var == 1) { 		//enable the SI interrupt
	brd_led_enable(BRD_LED0); 
	brd_led_enable(BRD_LED1);
	asm("	SSBX 1, 13");
	asm("	STM #5,IFR");	// Clear the interrupt0 so may be used again (IFR)
	asm(" 	STM #4,0h");		//but disable it until SI interrupt service routine 
	}							//completes,and enable SI interrupt 1 (IMR)
	
if (codewheel_var == 0)	{ 		//keep waiting, dont enable SI interrupt
	brd_led_disable(BRD_LED0); 
	brd_led_disable(BRD_LED1);
	brd_led_disable(BRD_LED2);
	}
asm(" RSBX INTM");		//globally enable interrupts

/* END of codewheel__interrupt0 */
}

/*************************************************************************************************
------------------------------- SI_interrupt ---------------------------------------------------
1. record the CCD output (57 samples after SI pulse)
2. determine braille cell
	-determine dots within image slice of 57 samples
	-store then correlate with previous or latter slices constituting a braille cell
	-determine braille cell
3. apply braille rules to create text from braille cells and rules
*************************************************************************************************/
interrupt void SI_interrupt2()
{

asm(" SSBX INTM");		// Disable interrupts

//------------ 1. record the CCD output (57 samples after SI pulse)--------------	
while (i < 59)
    {
       /* Wait for sample from handset */
       while (!MCBSP_RRDY(HANDSET_CODEC)) {};

       /* Read sample from and write back to handset codec */
       data = *(volatile u16*)DRR1_ADDR(HANDSET_CODEC);
       data_array[i] = data;
	   ++i;
    }

/*----------2. determine braille cell-----------------------------------
  a. use at least 3 image slices to detemine dots in a "slice', since ccd
 	 may not be perfectly horizontal
  b. apply fuzzy logic fundamentals to determine dots within sample array*/
/* i = 20;	// first 20 samples are out of lens view
 while (i < 58) {
 	if (newline_var == 20) {printf("\n"); newline_var = 0;}	//prevent output window horizontal overflow
	printf(" %d",  data_array[i]);
	++i;
	++newline_var;
	}
*/	
reference_amplitudeL = ((data_array[27] / 3) + (data_array[28] / 3) + (data_array[29] / 3));	//divide by 3 to prevent overflow
reference_amplitudeR = ((data_array[50] / 3) + (data_array[51] / 3) + (data_array[52] / 3));	//divide by 3 to prevent overflow
if (reference_amplitudeL >= reference_amplitudeR)		//try find reference amplitude least
	{reference_amplitude = reference_amplitudeL;}		//affected by dot shadows
else { reference_amplitude = reference_amplitudeR;}
	
sam31 = (reference_amplitude - data_array[31]);	//since the sample is subbed from the reference
sam32 = (reference_amplitude - data_array[32]); //it does no matter if the dot is not there
sam33 = (reference_amplitude - data_array[33]); //because the result will be almost zero and thus
sam34 = (reference_amplitude - data_array[34]); //does not affect the fuzzy determined result	
sam35 = (reference_amplitude - data_array[35]); // (the dot shadow due to its limited size is only
sam36 = (reference_amplitude - data_array[36]); // ever going to affect a few of the samples)
sam37 = (reference_amplitude - data_array[37]);		
sam37 = (reference_amplitude - data_array[38]);
sam39 = (reference_amplitude - data_array[39]);
sam40 = (reference_amplitude - data_array[40]); 	
sam41 = (reference_amplitude - data_array[41]);  	
sam42 = (reference_amplitude - data_array[42]);  	
sam43 = (reference_amplitude - data_array[43]);  		
sam43 = (reference_amplitude - data_array[44]);
sam45 = (reference_amplitude - data_array[45]); 
sam46 = (reference_amplitude - data_array[46]);	
sam47 = (reference_amplitude - data_array[47]);  	
sam48 = (reference_amplitude - data_array[48]); 	
  		
//determine using fuzzy priniciples if a dot exists 
dot1_value = ((sam31 /10)+(sam32 /10)+(sam33 /10)+(sam34 /10)+(sam35 /10)+(sam36 /20)+(sam37 /50));		//divide by 5 to prevent overflow
dot2_value = ((sam37 /40)+(sam38 /20)+(sam39 /10)+(sam40 /10)+(sam41 /10)+(sam42 /20)+(sam43 /40));		//divide by 5 to prevent overflow
dot3_value = ((sam42 /50)+(sam43 /20)+(sam44 /10)+(sam45 /10)+(sam46 /10)+(sam47 /10)+(sam48 /30));		//divide by 5 to prevent overflow
if (dot1_value > (reference_amplitude / 6)) { dot1 = 1; dot1_new = 1;}	
else { dot1 = 0; dot1_new = 0;}
if (dot2_value > (reference_amplitude / 6)) { dot2 = 1; dot2_new = 1;}
else { dot2 = 0; dot2_new = 0;}
if (dot3_value > (reference_amplitude / 6)) { dot3 = 1; dot3_new = 1;}		
else { dot3 = 0; dot3_new = 0;}


//to fix vertical misaligment of braille dots, make determined slice a culmination of a few horizontal slices
if ((dot1 == 1) || (dot1_old1 == 1)) {dot1 = 1;}	
if ((dot2 == 1) || (dot2_old1 == 1)) {dot2 = 1;}	
if ((dot3 == 1) || (dot3_old1 == 1)) {dot3 = 1;}
dot1_old1 = dot1_new; 		//refresh dots to culminate new dots with
dot2_old1 = dot2_new; 
dot3_old1 = dot3_new;
//printf("%d%d%d   %d %d %d %d ", dot1, dot2, dot3, dot1_value, dot2_value, dot3_value, reference_amplitude);

//get highest value image over range of slices affected by dot shadow for correct braille cell
slice_new = (dot1 * 0x04) + (dot2 * 0x02) + (dot3 * 0x01);  //ie, 110=0x06, 011=0x03, 001=0x01 etc 
if ((slice_old1 >= slice_old2) && (slice_old1 > slice_new)) { slice_goodnew = slice_old1;}
else {slice_goodnew = 0;}
//printf ("%d ", slice_goodnew);
/*if (newline_var == 50) { printf("\n"); newline_var = 0;}
++newline_var;*/

slice_old2 = slice_old1;		//refresh the reference slices
slice_old1 = slice_new;

//correlate dots on right hand side of braille cell with dots on left hand side of braille cell
if ((slice_goodnew != 0) && (slice_good9 != 0)) { 		//for double sided braille cells
	braille_cell = slice_goodnew + (slice_good9 *8);	//only good_slice 3,4, or 5 will != 0
	printf("bc=%d %c \n", braille_cell, bin2char[braille_cell]);}
if ((slice_goodnew != 0) && (slice_good8 != 0)) { 		
	braille_cell = slice_goodnew + (slice_good8 *8);	
	printf("bc=%d %c \n", braille_cell, bin2char[braille_cell]);}
if ((slice_goodnew != 0) && (slice_good7 != 0)) { 		
	braille_cell = slice_goodnew + (slice_good7 *8);	
	printf("bc=%d %c \n", braille_cell, bin2char[braille_cell]);}
if ((slice_goodnew != 0) && (slice_good6 != 0)) { 		
	braille_cell = slice_goodnew + (slice_good6 *8);
	printf("bc=%d %c \n", braille_cell, bin2char[braille_cell]);}
if ((slice_goodnew != 0) && (slice_good5 != 0)) { 
	braille_cell = slice_goodnew + (slice_good5 *8);
	printf("bc=%d %c \n", braille_cell, bin2char[braille_cell]);}

//for single sided braille cells display, check it really isn't a double sided cell,
//refer to figure "1-1-1-0-1-1 cell with vertical misalignment correction" for understanding	
if ((slice_good9 != 0) && (slice_goodnew == 0) && (slice_good1 == 0) && (slice_good2 == 0) &&(slice_good3 == 0) &&(slice_good4 == 0) &&(slice_good14 == 0) && (slice_good15 == 0) && (slice_good16 == 0) && (slice_good17 == 0) && (slice_good18 == 0)) { 		
	braille_cell = slice_good9 *8; 				//if assume is left side print  
	printf("bc=%d %c \n", braille_cell, bin2char[braille_cell]);
	/*braille_cell = slice_good9;					//if assume is right side
	printf("bc=%d %c \n", braille_cell, bin2char[braille_cell]);*/
	} 

//-------------3. apply braille rules to create text from braille cells and rules--------
/* for literary braille, need to test
	- is letter indicator
	- is capital indicator
	- is number indicator
	- is decimal point or letter 'k' etc etc*/

/*printf("%c",bin2CAP[braille_cell]);
printf("%c",bin2NUM[braille_cell]);	*/





slice_good18 = slice_good17;		//refresh the reference correct slices
slice_good17 = slice_good16;
slice_good16 = slice_good15;
slice_good15 = slice_good14;
slice_good14 = slice_good13;		
slice_good13 = slice_good12;
slice_good12 = slice_good11;
slice_good11 = slice_good10;
slice_good10 = slice_good9;
slice_good9 = slice_good8;
slice_good8 = slice_good7;		
slice_good7 = slice_good6;
slice_good6 = slice_good5;
slice_good5 = slice_good4;	
slice_good4 = slice_good3;	
slice_good3 = slice_good2;
slice_good2 = slice_good1;
slice_good1 = slice_goodnew;

i = 0;				//re-initialise after each interrupt, for sample array
brd_led_toggle(BRD_LED2 );

asm(" STM #5,1h");	// Clear any previous interrupt in IFR
asm(" STM #1,0h");		// Enable the int0 interrupt, disable SI(int1) in IMR
asm(" RSBX INTM");		// globally disable interrupts	
	
/* END of SI_interrupt2 */
}


//********************** test direction of codewheel movement ************************************
extern int bio_test()
{
asm("_test_bio:");
asm("	LD #0, A ;Set return value to false ");
asm("	BC bio_low, NBIO ;NBIO = high");
asm("	;BIO = 0 => moving forward");
asm("	NOP");
asm("	NOP ");
asm("	LD #1, A ;Set return value to true ");
asm("	RET ;Card present, return normally");
asm("bio_low: ;bio is low ");
asm("	RET ;exit");
/* END of bio_test */
}

//************************ set up interrupts*******************************************************
void setup_interrupt()
{
	asm(" SSBX INTM");	// Globally disable interrupts
	asm(" STM #5,1h");	// Clear any previous interrupt in IFR
	asm(" STM #4,0h");	// Enable the int2 interrupt, disable codewheel(int0) in IMR
	asm(" RSBX INTM");	// Globally enable interrupts
}

